Package net.sf.saxon.functions

## Class SnapshotFn

- java.lang.Object
- - net.sf.saxon.functions.AbstractFunction
  - - net.sf.saxon.functions.SystemFunction
    - - net.sf.saxon.functions.SnapshotFn

- All Implemented Interfaces:
    `Callable`, `Function`, `GroundedValue`, `Item`, `Sequence`

      public class SnapshotFn
      extends SystemFunction

  XSLT 3.0 function snapshot(). This is like a deep-copy except that it also includes a shallow copy of all ancestors.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SnapshotFn()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Sequence` | `call​(XPathContext context, Sequence[] arguments)` | Evaluate the expression
    `static void` | `closeAncestors​(java.util.List<NodeInfo> ancestors, Receiver bm)` |
    `int` | `getCardinality​(Expression[] arguments)` | Get the cardinality, given knowledge of the actual arguments
    `static ItemMappingFunction` | `getMappingFunction()` | Get a mapping function that can be used to take a snapshot of every item in a sequence
    `java.lang.String` | `getStreamerName()` | Get a name that identifies the class that can be used to evaluate this function in streaming mode, that is, supplying one item or event at a time as it is delivered by the parser.
    `static java.util.List<NodeInfo>` | `makeAncestorList​(NodeInfo origin)` |
    `static BuilderMonitor` | `openAncestors​(NodeInfo origin, java.util.List<NodeInfo> ancestors, XPathContext context)` |
    `static SequenceIterator` | `snapshotSequence​(SequenceIterator nodes, XPathContext context)` |
    `static Item` | `snapshotSingle​(Item origin)` | Take a snapshot of a single item

    - ### Methods inherited from class net.sf.saxon.functions.SystemFunction

      `dependsOnContextItem, dynamicCall, equals, export, exportAdditionalArguments, exportAttributes, fixArguments, getArity, getCompilerName, getContextNode, getDescription, getDetails, getErrorCodeForTypeErrors, getFunctionItemType, getFunctionName, getIntegerBounds, getNetCost, getOperandRoles, getRequiredType, getResultItemType, getResultItemType, getRetainedStaticContext, getSpecialProperties, getStaticBaseUriString, importAttributes, isTrustedResultType, makeCall, makeFunction, makeFunctionCall, makeOptimizedFunctionCall, resultIfEmpty, setArity, setDetails, setRetainedStaticContext, supplyTypeInformation, toShortString, toString, typeCheckCaller`

    - ### Methods inherited from class net.sf.saxon.functions.AbstractFunction

      `atomize, deepEquals, effectiveBooleanValue, getAnnotations, getStringValue, getStringValueCS, isArray, isMap, makeNewContext, simplify, typeCheck`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.Function

      `getGenre`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, head, isStreamed, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Constructor Detail

    - #### SnapshotFn

          public SnapshotFn()

  - ### Method Detail

    - #### getCardinality

          public int getCardinality​(Expression[] arguments)

      Description copied from class: `SystemFunction`
      Get the cardinality, given knowledge of the actual arguments
      Overrides:
        `getCardinality` in class `SystemFunction`
      Parameters:
        `arguments` - the actual arguments supplied
      Returns:
        the most precise available cardinality that the function will return

    - #### call

          public Sequence call​(XPathContext context,
                               Sequence[] arguments)
                        throws XPathException

      Evaluate the expression
      Parameters:
        `context` - the dynamic evaluation context
        `arguments` - the values of the arguments, supplied as Sequences
      Returns:
        the result of the evaluation, in the form of a Sequence
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the expression

    - #### snapshotSequence

          public static SequenceIterator snapshotSequence​(SequenceIterator nodes,
                                                          XPathContext context)

    - #### getMappingFunction

          public static ItemMappingFunction getMappingFunction()

      Get a mapping function that can be used to take a snapshot of every item in a sequence
      Returns:
        a suitable mapping function

    - #### snapshotSingle

          public static Item snapshotSingle​(Item origin)

      Take a snapshot of a single item
      Parameters:
        `origin` - the item in question
      Returns:
        the snapshot

    - #### makeAncestorList

          public static java.util.List<NodeInfo> makeAncestorList​(NodeInfo origin)

    - #### openAncestors

          public static BuilderMonitor openAncestors​(NodeInfo origin,
                                                     java.util.List<NodeInfo> ancestors,
                                                     XPathContext context)
                                              throws XPathException

      Throws:
        `XPathException`

    - #### closeAncestors

          public static void closeAncestors​(java.util.List<NodeInfo> ancestors,
                                            Receiver bm)
                                     throws XPathException

      Throws:
        `XPathException`

    - #### getStreamerName

          public java.lang.String getStreamerName()

      Description copied from class: `SystemFunction`
      Get a name that identifies the class that can be used to evaluate this function in streaming mode, that is, supplying one item or event at a time as it is delivered by the parser. Special streaming support is generally available in Saxon-EE for all system functions that take a sequence as their argument.
      Overrides:
        `getStreamerName` in class `SystemFunction`
      Returns:
        a name that identifies a class that supports streamed evaluation of this system function, or null if no such class is available. The mapping of names to classes is defined in the Saxon-EE class `StreamerMap`. In non-streaming Saxon editions (HE and PE) the method always returns null.